unit MainFrm;

interface

uses   
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables, ExtCtrls, Grids, DBGrids,
  Mask, Consts, ComCtrls, QSelect, DBCtrls, Tabnotbk, Buttons;

type
  TMainForm = class(TForm)
    QSelect: TQuickSelect;
    DataSource: TDataSource;
    Query: TQuery;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    SQLMmo: TMemo;
    DBGrid: TDBGrid;
    Panel5: TPanel;
    Panel6: TPanel;
    DBNavigator1: TDBNavigator;
    BuildBtn: TButton;
    ExitBtn: TButton;
    ExecuteBtn: TButton;
    procedure BuildBtnClick(Sender: TObject);
    procedure ExecuteBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure QSelectPreview(Sender: TObject; SQL: TStrings;
      Report: TQSReportType);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses URTypDlg;

{$R *.DFM}

procedure TMainForm.BuildBtnClick(Sender: TObject);
begin
  if QSelect.Execute then
  begin
    SQLMmo.Lines := QSelect.SQL;
  end;
end;

procedure TMainForm.ExecuteBtnClick(Sender: TObject);
begin
  if Query.Active then Query.Close;
  Query.SQL := SQLMmo.Lines;
  Query.Open;
end;

procedure TMainForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.QSelectPreview(Sender: TObject; SQL: TStrings;
  Report: TQSReportType);
begin
  DataSource.DataSet := nil;

  Query.SQL := SQL;
  try
    Query.Open;
    MessageDlg ('The query returns ' + IntToStr (Query.RecordCount) + ' rows  ',mtInformation,[mbOK],0);
  finally
    Query.Close;
  end;

  DataSource.DataSet := Query;
end;

end.


